// Emacs will be in -*- Mode: c++ -*-
//
// ********** DO NOT REMOVE THIS BANNER **********
//
// SUMMARY: Language for a Finite Element Method
// RELEASE: 2.0     
// USAGE  : You may copy freely these files and use it for    
//          teaching or research. These or part of these may   
//          not be sold or used for a commercial purpose with- 
//          out our consent : fax (33)1 44 27 44 11        
//
// AUTHORS:  D. Bernardi, Y. Darmaillac F. Hecht,    
//           P. Parole O. Pironneau C. Prud'homme
// ORG    :          
// E-MAIL :   pironneau@ann.jussieu.fr     
//
// ORIG-DATE:     June-94
// LAST-MOD:      3-Jan-96 at 13:40:55 by Prud'homme Christophe
//
// DESCRIPTION:  
// DESCRIP-END.
//

#ifndef __FEM1_H
#define __FEM1_H 1

float id(const float x);
//float norm2( float a);
float norm(const float x, const float y);

void rhsPDE(int quadra, float*  fw, float*  f, float*  g);
       
float gaussband (float*  a, float*  x, long n, long bdthl, int first, float eps);

float pdeian(float*  a, float*  u, float*  f, float*  g, float*  u0, 
        float*  alpha, float*  rho11, float*  rho12, float*  rho21, float*  rho22,
        float*  u1, float*  u2, float*  beta, int quadra, int factorize);

#endif /* __FEM1_H */
